//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern int    ForcePeriod      =   2;
extern int    MacdFastPeriod   =  60;
extern int    MacdSlowPeriod   = 130;
extern int    MacdSignalPeriod =  45;
extern int    BullBearPeriod   =  13;
extern int    Price            = PRICE_CLOSE;

//
//
//
//
//

double signalDn[];
double signalUp[];

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, signalDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, signalUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][7];
#define _force 0
#define _macdv 1
#define _macds 2
#define _macdo 3
#define _bullp 4
#define _bearp 5
#define _trend 6

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_macdv] = iMA(NULL,0,MacdFastPeriod,0,MODE_EMA,Price,i)-iMA(NULL,0,MacdSlowPeriod,0,MODE_EMA,Price,i);
      work[r][_bullp] = iBullsPower(NULL,0,BullBearPeriod,Price,i);
      work[r][_bearp] = iBearsPower(NULL,0,BullBearPeriod,Price,i);
      work[r][_force] = iForce(NULL,0,ForcePeriod,MODE_EMA,Price,i);
      work[r][_trend] = work[r-1][_trend];
       
      //
      //
      //
      //
      //
         
      signalDn[i]=EMPTY_VALUE;
      signalUp[i]=EMPTY_VALUE;
      if (work[r][_macdv]>0 && work[r][_bearp]<0 && work[r][_bearp]>work[r-1][_bearp] && work[r][_force]<0 && work[r][_force]>work[r-1][_force]) work[r][_trend] =  1;
      if (work[r][_macdv]<0 && work[r][_bullp]>0 && work[r][_bullp]<work[r-1][_bullp] && work[r][_force]>0 && work[r][_force]<work[r-1][_force]) work[r][_trend] = -1;
         double cOpen  = Open[i];
         double cClose = Close[i];
      if (work[r][_trend]==-1) { signalDn[i]=MathMax(cClose,cOpen); signalUp[i]=MathMin(cClose,cOpen); }
      if (work[r][_trend]== 1) { signalDn[i]=MathMin(cClose,cOpen); signalUp[i]=MathMax(cClose,cOpen); }
   }
   return(0);
}